//*****************************************************************************
// TimerTest.cpp
//*****************************************************************************
	#include <avr/io.h>
	#include <avr/interrupt.h>

	#include <iopins.h>
	#include <pinlist.h>

//#include <timer0.h>                              // OLD
	#include <ATmega-164-324-644-1284/Timer_local.h> // NEW

	using namespace Mcucpp;
	using namespace IO;
	using namespace Timers;
//*****************************************************************************
	ISR(TIMER0_OVF_vect)  { Porta::Toggle(0xFF); 
	}

	ISR(TIMER0_COMPA_vect){ Portb::Toggle(0xFF); 
	}

	ISR(TIMER1_OVF_vect) {  Portc::Toggle(0xFF);
	}

	ISR(TIMER2_OVF_vect) {  Portd::Toggle(0xFF);
	}

	int main() {
//*****************************************************************************
		Porta::SetConfiguration(0xff, Porta::Out); //-> DDRA = 0xff;
		Portb::SetConfiguration(0xff, Portb::Out); //-> DDRB = 0xff;
		Portc::SetConfiguration(0xff, Portc::Out); //-> DDRC = 0xff;
		Portd::SetConfiguration(0xff, Portd::Out); //-> DDRD = 0xff;

	//***************************************************************************
	//Timer0::OutputCompare<0xA>::Set             (F_CPU/256*1e-3 -1 );
	//Timer0::OutputCompare<0xA>::EnableInterrupt ();                   // OLD
	//***************************************************************************
		Timer0::OutputCompareA::Set             (F_CPU/256*1e-3 -1 );
		Timer0::OutputCompareA::EnableInterrupt ();
		Timer0::                SetMode         (Timer0::ClearOnCompare);
		Timer0::                EnableInterrupt ();
		Timer0::                Start           (Timer0::Div256);           // NEW
	//***************************************************************************
		Timer1::                SetMode         (Timer1::Normal);
		Timer1::                EnableInterrupt ();
		Timer1::                Start           (Timer1::Div256);            //NEW
	//***************************************************************************
		Timer2::                SetMode         (Timer2::Normal);
		Timer2::                EnableInterrupt ();
		Timer2::                Start           (Timer2::Div256);            //NEW
	//***************************************************************************
		sei();

		uint8_t sreg = SREG;

		while(1) { }

		return 0;
	} //____________________________________________________________a.b.08.2015__
